/* tela.cpp - executa o gerenciamento de tela */

#include <conio.h>
#include <string.h>
#include <ctype.h>
#include <bios.h>
#include <dos.h>

#include "tela.h"

/*--------------------------------------------------------------------------*\
 | tela::moldura - desenha uma modura no video.                             |
 |                                                                          |
 | Recebe - As coordenadas do video e o tipo da moldura.                    |
 |                                                                          |
 | Retorna - Nada.                                                          |
\*--------------------------------------------------------------------------*/

void tela::moldura (const int X1, const int Y1, const int X2, const int Y2,
		    const int i_tipo)

{
  int i_cont;

  gotoxy (X1, Y1);  /* Escolha caracter superior esquerdo.*/

  switch (i_tipo) {
    case 1: putch (201); break;
    case 2: putch (177); break;
    case 3: putch (214); break;
    case 4: putch (213); break;
    case 5: putch (176); break;
    case 6: putch (218); break;
    case 7: putch (178); break;
    case 8: putch (219); break;
  }

  gotoxy (X2, Y1);  /* Escolha caracter superior direito.*/

  switch (i_tipo) {
    case 1: putch (187); break;
    case 2: putch (177); break;
    case 3: putch (183); break;     
    case 4: putch (184); break;
    case 5: putch (176); break;
    case 6: putch (191); break;
    case 7: putch (178); break;
    case 8: putch (219); break;
  }

  gotoxy (X1,Y2);  /* Escolha caracter inferior esquerdo.*/

  switch (i_tipo) {
    case 1: putch (200); break;
    case 2: putch (177); break;
    case 3: putch (211); break;
    case 4: putch (212); break;
    case 5: putch (176); break;
    case 6: putch (192); break;
    case 7: putch (178); break;
    case 8: putch (219); break;
  }

  gotoxy (X2, Y2);  /* Escolha caracter inferior direito.*/

  switch (i_tipo) {
    case 1: putch (188); break;
    case 2: putch (177); break;
    case 3: putch (189); break;
    case 4: putch (190); break;
    case 5: putch (176); break;
    case 6: putch (217); break;
    case 7: putch (178); break;
    case 8: putch (219); break;
  }

  for (i_cont = Y1 + 1; i_cont < Y2; i_cont++) {

    gotoxy (X1, i_cont);  /* Linha vertical esquerda. */

    switch (i_tipo) {
      case 1: putch (186); break;
      case 2: putch (177); break;
      case 3: putch (186); break;
      case 4: putch (179); break;
      case 5: putch (176); break;
      case 6: putch (179); break;
      case 7: putch (178); break;
      case 8: putch (219); break;
    }

    gotoxy (X2, i_cont);  /* Linha vertical direita. */

    switch (i_tipo) {
      case 1: putch (186); break;
      case 2: putch (177); break;
      case 3: putch (186); break;
      case 4: putch (179); break;
      case 5: putch (176); break;
      case 6: putch (179); break;
      case 7: putch (178); break;
      case 8: putch (219); break;
    }
  }

  for (i_cont = X1 + 1; i_cont < X2; i_cont++) {

    gotoxy  (i_cont, Y1);  /* Linha horizontal superior. */

    switch (i_tipo) {
      case 1: putch (205); break;
      case 2: putch (177); break;
      case 3: putch (196); break;
      case 4: putch (205); break;
      case 5: putch (176); break;
      case 6: putch (196); break;
      case 7: putch (178); break;
      case 8: putch (219); break;
    }

    gotoxy (i_cont, Y2);  /* Linha direita. */

    switch (i_tipo)
    {
      case 1: putch (205); break;
      case 2: putch (177); break;
      case 3: putch (196); break;
      case 4: putch (205); break;
      case 5: putch (176); break;
      case 6: putch (196); break;
      case 7: putch (178); break;
      case 8: putch (219); break;
    }
  }
}

/*--------------------------------------------------------------------------*\
 | tela::escreve_esquerda - escreve no lado esquerdo da tela.               |
 |                                                                          |
 | Recebe - A linha do video para escrever a mensagem e a propria mensagem. |
 |                                                                          |
 | Retorna - Nada.                                                          |
\*--------------------------------------------------------------------------*/

void tela::escreve_esquerda (const i_linha, const char *cpz_informacao)

{

  gotoxy (3, i_linha);
  cprintf (cpz_informacao);

}


/*--------------------------------------------------------------------------*\
 | tela::escreve_meio - escreve no meio da tela.                            |
 |                                                                          |
 | Recebe - A linha do video para escrever a mensagem e a propria mensagem. |
 |                                                                          |
 | Retorna - Nada.                                                          |
\*--------------------------------------------------------------------------*/

void tela::escreve_meio (const i_linha, const char *cpz_informacao)

{

  int i_coluna = (80 - strlen (cpz_informacao)) / 2;

  gotoxy (i_coluna, i_linha);
  cprintf (cpz_informacao);

}

/*--------------------------------------------------------------------------*\
 | tela::escreve_direita - escreve no lado direito da tela.                 |
 |                                                                          |
 | Recebe - A linha do video para escrever a mensagem e a propria mensagem. |
 |                                                                          |
 | Retorna - Nada.                                                          |
\*--------------------------------------------------------------------------*/

void tela::escreve_direita (const i_linha, const char *cpz_informacao)

{

  int i_coluna = 78 - strlen (cpz_informacao);

  gotoxy (i_coluna, i_linha);
  cprintf (cpz_informacao);

}


/*--------------------------------------------------------------------------*\
 | tela::apaga_mensagem - preenche de epacos o local de mensagens.          |
 |                                                                          |
 | Recebe - Nada.                                                           |
 |                                                                          |
 | Retorna - Nada.                                                          |
\*--------------------------------------------------------------------------*/

void tela::apaga_mensagem (void)

{

  gotoxy (2, 23);
  for (int i = 2; i < 79; i++)
   putch (' ');

}

/*--------------------------------------------------------------------------*\
 | tela::beep - executa um sinal sonoro.                                    |
 |                                                                          |
 | Recebe - Nada.                                                           |
 |                                                                          |
 | Retorna - Nada.                                                          |
\*--------------------------------------------------------------------------*/

void tela::beep (void)

{

  sound (500);
  delay (10);
  nosound ();

}

/*--------------------------------------------------------------------------*\
 | tela::preenche_espacos - completa a variavel com espacos ate o seu       |
 |                          tamanho maximo.                                 |
 |                                                                          |
 | Recebe - A variavel a ser modificada e o seu tamanho maximo.             |
 |                                                                          |
 | Retorna - A variavel modificada.                                         |
\*--------------------------------------------------------------------------*/

void tela::preenche_espacos (char *cpz_linha, const int i_tam)

{

  for (int i_cont = strlen (cpz_linha); i_cont < i_tam; i_cont++)
    cpz_linha [i_cont] = ' ';

}

/*--------------------------------------------------------------------------*\
 | tela::edita_linha - executa a edicao de uma linha.                       |
 |                                                                          |
 | Recebe - As coordenadas do video para a edicao, um ponteiro para a linha,|
 |          e o seu tamanho maximo.                                         |
 |                                                                          |
 | Retorna - A linha editada.                                               |
\*--------------------------------------------------------------------------*/

int tela::edita_campo (const int i_coluna, const int i_linha,
		       char *cpz_linha, const int i_tam)
{

  char *cpz_linha_modif = new char [i_tam];

  int i_coluna_cursor = 0;  // localizacao do cursor dentro da linha
  int i_comando;            // comando recebido pelo teclado
  char c_caracter;          // comando de troca de letra

  preenche_espacos (cpz_linha, i_tam);

  /* salva a linha anterior */

  for (int i = 0; i < i_tam; i++)
    cpz_linha_modif [i] = cpz_linha [i];


  /* coloca a linha na tela */

  gotoxy (i_coluna, i_linha);
  for (int i_pos = 0; i_pos < i_tam; i_pos++) {
    gotoxy (i_coluna + i_pos, i_linha);
    putch (cpz_linha [i_pos]);
  }
  gotoxy (i_coluna, i_linha);

  do {
    while (bioskey (_KEYBRD_READY) == 0)
    ;

    i_comando = bioskey (_KEYBRD_READ);

    if (isprint (c_caracter = (i_comando & 0xFF))) {
      if (i_coluna_cursor < i_tam) {

	if (c_caracter >= 'a' && c_caracter <= 'z')
	  c_caracter -= 32;

	cpz_linha_modif [i_coluna_cursor] = c_caracter;

	putch (c_caracter);
	i_coluna_cursor++;
	gotoxy (i_coluna + i_coluna_cursor, i_linha);
      }
      else
	beep ();
    }
    else
      switch (i_comando) {

	case (BACKSPACE):

	  if (i_coluna_cursor > 0) {
	    i_coluna_cursor--;
	    gotoxy (i_coluna + i_coluna_cursor, i_linha);
	    putch (' ');
	    cpz_linha_modif [i_coluna_cursor] = ' ';
	    gotoxy (i_coluna + i_coluna_cursor, i_linha);
	  }
	  else
	    beep ();

	  break;

	case (DELETE): {
	  if (i_coluna_cursor == i_tam) {
	    beep ();
	    break;
	  }
	  else
	    if (i_coluna_cursor == i_tam - 1) {
	      gotoxy (i_coluna + i_coluna_cursor, i_linha);
	      putch (' ');
	      cpz_linha_modif [i_coluna_cursor] = ' ';
	      gotoxy (i_coluna + i_coluna_cursor, i_linha);
	      break;
	    }
	  for (int i_col = i_coluna_cursor; i_col <= i_tam - 2; i_col++) {
	    gotoxy (i_coluna + i_col, i_linha);
	    putch (cpz_linha_modif [i_col] = cpz_linha_modif [i_col + 1]);
	  }
	  gotoxy (i_coluna + i_tam - 1, i_linha);
	  putch (cpz_linha_modif [i_tam - 1] = ' ');
	  gotoxy (i_coluna + i_coluna_cursor, i_linha);
	  break;
	}

	case (SETA_DIREITA):

	  if (i_coluna_cursor < i_tam) {
	    i_coluna_cursor++;
	    gotoxy (i_coluna + i_coluna_cursor, i_linha);
	  }
	  else
	    beep ();

	  break;

	case (SETA_ESQUERDA):

	  if (i_coluna_cursor > 0) {
	    i_coluna_cursor--;
	    gotoxy (i_coluna + i_coluna_cursor, i_linha);
	  }
	  else
	    beep ();

	  break;

	case (ENTER):
	case (ESC):
	case (SETA_CIMA):
	case (SETA_BAIXO):

	  break;

	default:

	  beep (); // Teclas invalidas como F1, etc
      }

  } while (i_comando != ENTER &&
	   i_comando != ESC &&
	   i_comando != SETA_CIMA &&
	   i_comando != SETA_BAIXO);

  for (int i_posicao_atual = i_tam - 1; // Procura a ultima letra da linha
       i_posicao_atual > 0;
       i_posicao_atual--)
    if (cpz_linha_modif [i_posicao_atual] != ' ')
      break;

  strncpy (cpz_linha, cpz_linha_modif, i_tam);
  cpz_linha [++i_posicao_atual] = NULO;        // Delimita a linha

  delete cpz_linha_modif;

  gotoxy (i_coluna, i_linha);            // Mostra a linha modificada
  for (int i_pos_rep = 0; i_pos_rep < i_posicao_atual; i_pos_rep++) {
    gotoxy (i_coluna + i_pos_rep, i_linha);
    putch (cpz_linha [i_pos_rep]);
  }
  for (int j = i_posicao_atual; j < i_tam; j++) { // Preenche o resto
    gotoxy (i_coluna + j, i_linha);               // com espacos em branco
    putch (' ');
  }

  switch (i_comando) {

    case (ENTER):
    case (SETA_BAIXO):

      return (DESCE);

    case (SETA_CIMA):

      return (SOBE);

  }

  return (SAI);

}


/*--------------------------------------------------------------------------*\
 | tela::tela - desenha a estrutura da tela.                                |
 |                                                                          |
 | Recebe - O titulo da tela.                                               |
 |                                                                          |
 | Retorna - Nada.                                         (Sobrecarregada) |
\*--------------------------------------------------------------------------*/

tela::tela (const char *cpz_titulo)

{

  cpz_titulo_tela = new char [strlen (cpz_titulo) + 1];
  strcpy (cpz_titulo_tela, cpz_titulo);

  clrscr ();
  moldura (1, 1, 80, 5, MOLD_DUPLO_AMBAS);
  escreve_meio (2, AGENDA);
  escreve_esquerda (4, EMPRESA);
  escreve_direita (4, cpz_titulo);


  moldura (1, 6, 80, 21, MOLD_SIMPLES);

  moldura (1, 22, 80, 24, MOLD_DUPLO_AMBAS);

}

/*--------------------------------------------------------------------------*\
 | tela::menu - Mostra as opcoes possiveis das terefas a serem executadas.  |
 |                                                                          |
 | Recebe - Nada.                                                           |
 |                                                                          |
 | Retorna - A opcao do ususario.                                           |
\*--------------------------------------------------------------------------*/

int tela::menu (void)

{

  escreve_meio (8, " 1 - Incluir   ");
  escreve_meio (10, " 2 - Alterar   ");
  escreve_meio (12, " 3 - Consultar ");
  escreve_meio (14, " 4 - Excluir   ");
  escreve_meio (16, " 5 - Listar    ");
  escreve_meio (18, " 6 - Fim       ");

  while (VERDADE) {

   gotoxy (3, 23);
   cprintf ("Opcao [ ]");
   gotoxy (10, 23);

   char i_caract = getch ();

   if (i_caract >= '1' || i_caract <= '5')
     switch (i_caract) {
       case '1': return INCLUIR;
       case '2': return ALTERAR;
       case '3': return CONSULTAR;
       case '4': return EXCLUIR;
       case '5': return LISTAR;
       case '6': return FIM;

     }

  }

}

/*--------------------------------------------------------------------------*\
 | tela::mensagem - envia uma mensagem para a tela e espera continuacao.    |
 |                                                                          |
 | Recebe - Um ponteiro para a mensagem.                                    |
 |                                                                          |
 | Retorna - Nada.                                                          |
\*--------------------------------------------------------------------------*/

void tela::mensagem (const char *cpz_mensagem)

{
  char *cpz_mensagem_completa = new char [strlen (cpz_mensagem) +
					  strlen (CONTINUAR) + 1];
  /* constroi mensagem */

  strcpy (cpz_mensagem_completa, cpz_mensagem);
  strcat (cpz_mensagem_completa, CONTINUAR);

  escreve_esquerda (23, cpz_mensagem_completa);

  getch ();

  apaga_mensagem ();

  delete cpz_mensagem_completa;

}


/*--------------------------------------------------------------------------*\
 | tela::confirmacao - envia um pedido de confirmacao.                      |
 |                                                                          |
 | Recebe - Um ponteiro para a mensagem.                                    |
 |                                                                          |
 | Retorna - A resposta do usuario.                                         |
\*--------------------------------------------------------------------------*/

int tela::confirmacao (const char *cpz_mensagem)

{

  int i_tam_mensagem = strlen (cpz_mensagem) + strlen (CONTINUAR);

  char *cpz_mensagem_completa = new char [i_tam_mensagem + 1];

  char resposta;

  /* constroi mensagem */

  strcpy (cpz_mensagem_completa, cpz_mensagem);
  strcat (cpz_mensagem_completa, CONFIRMACAO);

  escreve_esquerda (23, cpz_mensagem_completa);

  do {                               // Recebe confirmacao
    gotoxy (3 + i_tam_mensagem, 23);
    resposta = getche ();
  } while (resposta != 'S' && resposta != 's' &&
	   resposta != 'N' && resposta != 'n');

  delete cpz_mensagem_completa;

  apaga_mensagem ();

  if (resposta == 'S' || resposta == 's')
    return (SIM);

  return (NAO);

}

/*--------------------------------------------------------------------------*\
 | tela::edita_busca - altera ou recebe a informacao de busca.              |
 |                                                                          |
 | Recebe - Um ponteiro para a informacao e o seu limite de tamanho.          |
 |                                                                          |
 | Retorna - Um inteiro indicando algum comando, e a entidade modificada.   |
\*--------------------------------------------------------------------------*/

int tela::edita_busca (char *cpz_busca, const int i_tam)

{

  gotoxy (3, 8);
  cprintf ("Busca:");
  gotoxy (9 + i_tam, 8);
  putch (':');

  return (edita_campo (9, 8, cpz_busca, i_tam));

}


/*--------------------------------------------------------------------------*\
 | tela::edita_entidade - altera ou recebe o nome da entidade.              |
 |                                                                          |
 | Recebe - Um ponteiro para a entidade e o seu limite de tamanho.          |
 |                                                                          |
 | Retorna - Um inteiro indicando algum comando, e a entidade modificada.   |
\*--------------------------------------------------------------------------*/

int tela::edita_entidade (char *cpz_entidade, const int i_tam)

{

  gotoxy (3, 10);
  cprintf ("Entidade:");
  gotoxy (12 + i_tam, 10);
  putch (':');

  return (edita_campo (12, 10, cpz_entidade, i_tam));

}

/*--------------------------------------------------------------------------*\
 | tela::edita_telefone - altera ou recebe o telefone.                      |
 |                                                                          |
 | Recebe - Um ponteiro para o telefone e o seu limite de tamanho.          |
 |                                                                          |
 | Retorna - Um inteiro indicando algum comando, e a entidade modificada.   |
\*--------------------------------------------------------------------------*/

int tela::edita_telefone (char *cpz_telefone, const int i_tam)

{

  gotoxy (3, 12);
  cprintf ("Telefone:");
  gotoxy (12 + i_tam, 12);
  putch (':');

  return (edita_campo (12, 12, cpz_telefone, i_tam));

}

/*--------------------------------------------------------------------------*\
 | tela::edita_linha - altera ou recebe uma linha.                          |
 |                                                                          |
 | Recebe - Um inteiro indicando qual a linha que sera editada, um ponteiro |
 |          para a linha e o seu limite de tamanho.                         |
 |                                                                          |
 | Retorna - Um inteiro indicando algum comando, e a entidade modificada.   |
\*--------------------------------------------------------------------------*/

int tela::edita_linha (const int i_linha, char *cpz_linha, const int i_tam)

{

  gotoxy (3, 14 + i_linha);
  cprintf ("Linha %d :", i_linha + 1);
  gotoxy (12 + i_tam, 14 + i_linha);
  putch (':');

  return (edita_campo (12, 14 + i_linha, cpz_linha, i_tam));

}

/*--------------------------------------------------------------------------*\
 | tela::mostra_entidade - envia a entidade para o video.                   |
 |                                                                          |
 | Recebe - Um ponteiro para a entidade.                                    |
 |                                                                          |
 | Retorna - Nada.                                                          |
\*--------------------------------------------------------------------------*/

void tela::mostra_entidade (const char *cpz_entidade, const int i_tam)

{

  gotoxy (3, 10);
  cprintf ("Entidade:");
  gotoxy (12 + i_tam, 10);
  putch (':');

  gotoxy (12, 10);
  cprintf ("%s", cpz_entidade);

  for (int i = strlen (cpz_entidade); i < i_tam; i++) {
    gotoxy (12 + i, 10);
    putch (' ');
  }

}

/*--------------------------------------------------------------------------*\
 | tela::mostra_telefone - envia o telefone para o video.                   |
 |                                                                          |
 | Recebe - Um ponteiro para a telefone.                                    |
 |                                                                          |
 | Retorna - Nada.                                                          |
\*--------------------------------------------------------------------------*/

void tela::mostra_telefone (const char *cpz_telefone, const int i_tam)

{

  gotoxy (3, 12);
  cprintf ("Telefone:");
  gotoxy (12 + i_tam, 12);
  putch (':');

  gotoxy (12, 12);
  cprintf ("%s", cpz_telefone);

  for (int i = strlen (cpz_telefone); i < i_tam; i++) {
    gotoxy (12 + i, 12);
    putch (' ');
  }
}

/*--------------------------------------------------------------------------*\
 | tela::mostra_mensagem - envia uma linha para o vide.                     |
 |                                                                          |
 | Recebe - Um ponteiro para a mensagem.                                    |
 |                                                                          |
 | Retorna - Nada.                                                          |
\*--------------------------------------------------------------------------*/

void tela::mostra_linha (const int i_linha, const char *cpz_linha,
	   const int i_tam)

{

  gotoxy (3, 14 + i_linha);
  cprintf ("Linha %d :", i_linha + 1);
  gotoxy (12 + i_tam, 14 + i_linha);
  putch (':');

  gotoxy (12, 14 + i_linha);
  cprintf ("%s", cpz_linha);

  for (int i = strlen (cpz_linha); i < i_tam; i++) {
    gotoxy (12 + i, 14 + i_linha);
    putch (' ');
  }
}
