/* arquivo.h */

#include <string.h>
#include <conio.h>

#define EMPRESA     "ABC Assessoria Tcnica Contbil Ltda S/C"
#define AGENDA      "AGENDA TELEFONICA DE RPIDO USO"

#define CONTINUAR   " [ENTER]."
#define CONFIRMACAO " (S/N)? "

#define ENTER           7181
#define ESC              283
#define BACKSPACE       3592
#define DELETE         21248
#define SETA_CIMA      18432
#define SETA_BAIXO     20480
#define SETA_ESQUERDA  19200
#define SETA_DIREITA   19712

#define NULO    '\0'

#define SIM     1
#define NAO     0

#define SOBE    1
#define DESCE   2
#define SAI     3

#define INCLUIR    1
#define ALTERAR    2
#define CONSULTAR  3
#define EXCLUIR    4
#define LISTAR     5
#define FIM        6

#define MOLD_SIMPLES           6
#define MOLD_DUPLO_AMBAS       1
#define MOLD_DUPLO_VERT        3
#define MOLD_DUPLH_HOR         4
#define MOLD_CHEIO_FRACO       5
#define MOLD_CHEIO_MED         2
#define MOLD_CHEIO_FORTE       7
#define MOLD_CHEIO_COMPL       8

#define VERDADE    1
#define ERRO       0

#define APAGADA    0

class tela {

protected:

  char *cpz_titulo_tela;

  void moldura (const int X1, const int Y1, const int X2, const int Y2,
		const int i_tipo);

  void escreve_esquerda (const int i_linha, const char *cpz_informacao);
  void escreve_meio     (const int i_linha, const char *cpz_informacao);
  void escreve_direita  (const int i_linha, const char *cpz_informacao);

  void apaga_mensagem (void);

  void beep (void);

  void preenche_espacos (char *cpz_linha, const int i_tam);

  int edita_campo (const int i_coluna, const int i_linha,
		   char *cpz_linha, const int i_tam);

public:

  tela (void)
  {
    cpz_titulo_tela = NULL;

    clrscr ();
  }

  tela (const char *cpz_titulo);

  int menu ();

  void mensagem (const char *cpz_mensagem);

  int confirmacao (const char *cpz_mensagem);

  int edita_busca (char *cpz_busca, const int i_tam);

  int edita_entidade (char *cpz_entidade, const int i_tam);

  int edita_telefone (char *cpz_telefone, const int i_tam);

  int edita_linha (const int i_linha, char *cpz_linha, const int i_tam);

  void mostra_entidade (const char *cpz_entidade, const int i_tam);

  void mostra_telefone (const char *cpz_telefone, const int i_tam);

  void mostra_linha (const int i_linha, const char *cpz_linha,
		     const int i_tam);

  ~tela (void)
  {
    if (cpz_titulo_tela != NULL) {
      delete cpz_titulo_tela;
      cpz_titulo_tela = NULL;
    }
    clrscr ();
  };

};